defmodule DrainCloudCoreWeb.AuthController do
  use DrainCloudCoreWeb, :controller

  alias DrainCloudCoreWeb.AuthController.RegisterRequest, as: RegisterRequest
  alias DrainCloudCoreWeb.AuthController.LoginRequest, as: LoginRequest
  alias :logger, as: Log

  alias DrainCloudCore.Repo, as: Repo

  def register(conn, _params) do
    req = RegisterRequest.from_request(conn)

    Log.debug("new register request: #{req}")

    model = RegisterRequest.to_model(req)

    try do
      Repo.insert(model)
    rescue
      e in RuntimeError -> Log.error("failed to insert new user: #{e}")
    end

    json(conn, req)
  end

  def login(conn, _params) do
    req = LoginRequest.from_request(conn)

    Log.debug("new login request: #{req}")

  end
end
