defmodule DrainCloudCoreWeb.Errors.InvalidArgumentException do
  alias __MODULE__, as: InvalidArgumentException
  defexception [:message, :args]

  @impl true
  def exception(%{message: message, args: args}) do
    %InvalidArgumentException{message: message, args: args}
  end

  @impl true
  def exception(term) do
    case term do
      [] -> %InvalidArgumentException{}
      _ -> %InvalidArgumentException{message: "Error: " <> term}
    end
  end
end
